/* Ciurul (sita) lui Eratostene
 * Erathostene's sive
 * 
 * Se da un numar natural n <= 1000000
 * Sa se determine toate numerele prime 
 * din intervalul [1, n]
 * 
 * Ideea:
 * Consideram ca initial, toate numerele [2, 3 ...n] sunt prime (le punem in ciur)s
 * Dupa care, cernem sita, adica marcam ca neprime toti multimpii nr prime
 * gasite pana in acel moment
 */ 
#include <iostream>
using namespace std;

const int Max = 1e6 + 1;
bool prim[Max];

void Erathostene(int n);

int main()
{
	int n;
	cin >> n;
	Erathostene(n);
	
	for (int i = 2; i <= n; ++i)
		if (prim[i])
			cout << i << ' ';
	return 0;
}
// t t f t f t f t  f  t  f  t  f  t  f  t f
// 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18

// t t t t f  t  t f  t  t
// 2 3 5 7 9 11 13 15 17 19

// t t t t t  t  t  t
// 2 3 5 7 11 13 17 19
     
void Erathostene(int n)
{
	// presupunem ca initial, toate valorile sunt prime
	for (int i = 2; i <= n; ++i)
		prim[i] = true;
	
	// Aproape O(n) (putin mai mare)
	for (int i = 2; i * i <= n; ++i)
		if (prim[i])
			for (int j = 2; i * j <= n; ++j)
				prim[i * j] = false;			
}

